import javax.management.ObjectName;
import javax.management.Query;
import javax.management.openmbean.CompositeData;

import fr.ippon.groovy.util.WebLoMBean;

def mbs = WebLoMBean.getDomainMBeanServer('t3://localhost:7001', 'weblogic', 'weblogic')

def destFilter = javax.management.Query.with {
	match(attr('Name'),value('*@MyFirstDistributedQueue'))
}

def destinationMBeanNames = mbs.queryNames(new ObjectName('com.bea:Type=JMSDestinationRuntime,*'), destFilter)
def destinationMbeans = destinationMBeanNames.collect { new GroovyMBean(mbs, it) }

def selector = "JMSType = 'MyCustomJMSType'"

def describeCompositeData = { CompositeData item ->
	def compositeType = item.getCompositeType()
	def keySet = compositeType.keySet()
	keySet.each { key ->
		def opentype = compositeType.getType(key)
		// rq : tous les champs de ce compositeData sont des
		// javax.management.openmbean.SimpleType
		// Le type est accessible directement : 
		def type = opentype.className
		def description = compositeType.getDescription(key)
		def value = item.get(key)
		printf "  %-15s : %-17s -> %s %n    %s %n", key , type, description, value
	}
}

destinationMbeans.each { mbean ->

	def timeout = 1000
	def cursor = mbean.getMessages(selector, timeout)

	def nbMsg = mbean.getCursorSize(cursor)
	println "Found $nbMsg msg(s) on queue $mbean.Name"
	
	def batchSize = 10
	def readMessage = 0
	while(readMessage < nbMsg) {
		def items = mbean.getNext(cursor,batchSize)
		items.each { CompositeData item ->
			++readMessage
			println "\nMsg n$readMessage :"
//			describeCompositeData(item)
			
			def msgHandle = item['Handle']
			
//			def itemWithBody = mbean.getMessage(cursor,msgHandle) // ok sur WebLo 10 mais bug groovy sur WebLo 9 (http://jira.codehaus.org/browse/GROOVY-2807)
			def itemWithBody = mbean.server().invoke(
			        mbean.name(),
					'getMessage',
					[cursor,msgHandle] as Object[],
					['java.lang.String', 'java.lang.Long'] as String[])
					
			describeCompositeData(itemWithBody)
		}
	}
	mbean.closeCursor(cursor)
}
